( This is the fixed-width bitmap font from glcdfont.c for Adafruit_GFX )
( Converted to GForth by Assad Ebrahim - 2021-05-29---Sat---16:06 )
( OBSOLETED by 3iI2C.fs which has fast character display with embedded font management  -- 2021-07-24---Sat---02:41 )
( This file is now for the Forth driven slower code working from scratch  - no font info at all)
 

\ ASCII 5x7 wxh pixel font, 5 bytes each, so 1.3kB of memory for the full ASCII 256 characters, and 0.7kB for 128 chars
\ these are rotated cw 90 degrees so need to unrotate them.  
\ Why store this way?  to store them unrotated, would take more memory, 7 bytes using only 5 bits each, so X% less efficient
\ Also ** text-oriented OLED/LCD devices with text-oriented device driver ICs such as SSD1306 want the bytes in vertical format
\ Note: When sending to an OLED display device in bulk, we reverse them loading into the uC so hence the read from rawfont is fwd.

create rawfont  
	$00 c, $00 c, $00 c, $00 c, $00 c,
	$3E c, $5B c, $4F c, $5B c, $3E c,
	$3E c, $6B c, $4F c, $6B c, $3E c,
	$1C c, $3E c, $7C c, $3E c, $1C c,
	$18 c, $3C c, $7E c, $3C c, $18 c,
	$1C c, $57 c, $7D c, $57 c, $1C c,
	$1C c, $5E c, $7F c, $5E c, $1C c,
	$00 c, $18 c, $3C c, $18 c, $00 c,
	$FF c, $E7 c, $C3 c, $E7 c, $FF c,
	$00 c, $18 c, $24 c, $18 c, $00 c,
	$FF c, $E7 c, $DB c, $E7 c, $FF c,
	$30 c, $48 c, $3A c, $06 c, $0E c,   \ TEST: first non-symmetric row is  rawfont[11]    hex 0b getfont-fwd .s decimal
	$26 c, $29 c, $79 c, $29 c, $26 c,
	$40 c, $7F c, $05 c, $05 c, $07 c,
	$40 c, $7F c, $05 c, $25 c, $3F c,
	$5A c, $3C c, $E7 c, $3C c, $5A c,
	$7F c, $3E c, $1C c, $1C c, $08 c,
	$08 c, $1C c, $1C c, $3E c, $7F c,
	$14 c, $22 c, $7F c, $22 c, $14 c,
	$5F c, $5F c, $00 c, $5F c, $5F c,
	$06 c, $09 c, $7F c, $01 c, $7F c,
	$00 c, $66 c, $89 c, $95 c, $6A c,
	$60 c, $60 c, $60 c, $60 c, $60 c,
	$94 c, $A2 c, $FF c, $A2 c, $94 c,
	$08 c, $04 c, $7E c, $04 c, $08 c,
	$10 c, $20 c, $7E c, $20 c, $10 c,
	$08 c, $08 c, $2A c, $1C c, $08 c,
	$08 c, $1C c, $2A c, $08 c, $08 c,
	$1E c, $10 c, $10 c, $10 c, $10 c,
	$0C c, $1E c, $0C c, $1E c, $0C c,
	$30 c, $38 c, $3E c, $38 c, $30 c,
	$06 c, $0E c, $3E c, $0E c, $06 c,
	$00 c, $00 c, $00 c, $00 c, $00 c,
	$00 c, $00 c, $5F c, $00 c, $00 c,
	$00 c, $07 c, $00 c, $07 c, $00 c,
	$14 c, $7F c, $14 c, $7F c, $14 c,
	$24 c, $2A c, $7F c, $2A c, $12 c,
	$23 c, $13 c, $08 c, $64 c, $62 c,
	$36 c, $49 c, $56 c, $20 c, $50 c,
	$00 c, $08 c, $07 c, $03 c, $00 c,
	$00 c, $1C c, $22 c, $41 c, $00 c,
	$00 c, $41 c, $22 c, $1C c, $00 c,
	$2A c, $1C c, $7F c, $1C c, $2A c,
	$08 c, $08 c, $3E c, $08 c, $08 c,
	$00 c, $80 c, $70 c, $30 c, $00 c,
	$08 c, $08 c, $08 c, $08 c, $08 c,
	$00 c, $00 c, $60 c, $60 c, $00 c,
	$20 c, $10 c, $08 c, $04 c, $02 c,
	$3E c, $51 c, $49 c, $45 c, $3E c,
	$00 c, $42 c, $7F c, $40 c, $00 c,
	$72 c, $49 c, $49 c, $49 c, $46 c,
	$21 c, $41 c, $49 c, $4D c, $33 c,
	$18 c, $14 c, $12 c, $7F c, $10 c,
	$27 c, $45 c, $45 c, $45 c, $39 c,
	$3C c, $4A c, $49 c, $49 c, $31 c,
	$41 c, $21 c, $11 c, $09 c, $07 c,
	$36 c, $49 c, $49 c, $49 c, $36 c,
	$46 c, $49 c, $49 c, $29 c, $1E c,
	$00 c, $00 c, $14 c, $00 c, $00 c,
	$00 c, $40 c, $34 c, $00 c, $00 c,
	$00 c, $08 c, $14 c, $22 c, $41 c,
	$14 c, $14 c, $14 c, $14 c, $14 c,
	$00 c, $41 c, $22 c, $14 c, $08 c,
	$02 c, $01 c, $59 c, $09 c, $06 c,
	$3E c, $41 c, $5D c, $59 c, $4E c,
	$7C c, $12 c, $11 c, $12 c, $7C c,
	$7F c, $49 c, $49 c, $49 c, $36 c,
	$3E c, $41 c, $41 c, $41 c, $22 c,
	$7F c, $41 c, $41 c, $41 c, $3E c,
	$7F c, $49 c, $49 c, $49 c, $41 c,
	$7F c, $09 c, $09 c, $09 c, $01 c,
	$3E c, $41 c, $41 c, $51 c, $73 c,
	$7F c, $08 c, $08 c, $08 c, $7F c,
	$00 c, $41 c, $7F c, $41 c, $00 c,
	$20 c, $40 c, $41 c, $3F c, $01 c,
	$7F c, $08 c, $14 c, $22 c, $41 c,
	$7F c, $40 c, $40 c, $40 c, $40 c,
	$7F c, $02 c, $1C c, $02 c, $7F c,
	$7F c, $04 c, $08 c, $10 c, $7F c,
	$3E c, $41 c, $41 c, $41 c, $3E c,
	$7F c, $09 c, $09 c, $09 c, $06 c,
	$3E c, $41 c, $51 c, $21 c, $5E c,
	$7F c, $09 c, $19 c, $29 c, $46 c,
	$26 c, $49 c, $49 c, $49 c, $32 c,
	$03 c, $01 c, $7F c, $01 c, $03 c,
	$3F c, $40 c, $40 c, $40 c, $3F c,
	$1F c, $20 c, $40 c, $20 c, $1F c,
	$3F c, $40 c, $38 c, $40 c, $3F c,
	$63 c, $14 c, $08 c, $14 c, $63 c,
	$03 c, $04 c, $78 c, $04 c, $03 c,
	$61 c, $59 c, $49 c, $4D c, $43 c,
	$00 c, $7F c, $41 c, $41 c, $41 c,
	$02 c, $04 c, $08 c, $10 c, $20 c,
	$00 c, $41 c, $41 c, $41 c, $7F c,
	$04 c, $02 c, $01 c, $02 c, $04 c,
	$40 c, $40 c, $40 c, $40 c, $40 c,
	$00 c, $03 c, $07 c, $08 c, $00 c,
	$20 c, $54 c, $54 c, $78 c, $40 c,
	$7F c, $28 c, $44 c, $44 c, $38 c,
	$38 c, $44 c, $44 c, $44 c, $28 c,
	$38 c, $44 c, $44 c, $28 c, $7F c,
	$38 c, $54 c, $54 c, $54 c, $18 c,
	$00 c, $08 c, $7E c, $09 c, $02 c,
	$18 c, $A4 c, $A4 c, $9C c, $78 c,
	$7F c, $08 c, $04 c, $04 c, $78 c,
	$00 c, $44 c, $7D c, $40 c, $00 c,
	$20 c, $40 c, $40 c, $3D c, $00 c,
	$7F c, $10 c, $28 c, $44 c, $00 c,
	$00 c, $41 c, $7F c, $40 c, $00 c,
	$7C c, $04 c, $78 c, $04 c, $78 c,
	$7C c, $08 c, $04 c, $04 c, $78 c,
	$38 c, $44 c, $44 c, $44 c, $38 c,
	$FC c, $18 c, $24 c, $24 c, $18 c,
	$18 c, $24 c, $24 c, $18 c, $FC c,
	$7C c, $08 c, $04 c, $04 c, $08 c,
	$48 c, $54 c, $54 c, $54 c, $24 c,
	$04 c, $04 c, $3F c, $44 c, $24 c,
	$3C c, $40 c, $40 c, $20 c, $7C c,
	$1C c, $20 c, $40 c, $20 c, $1C c,
	$3C c, $40 c, $30 c, $40 c, $3C c,
	$44 c, $28 c, $10 c, $28 c, $44 c,
	$4C c, $90 c, $90 c, $90 c, $7C c,
	$44 c, $64 c, $54 c, $4C c, $44 c,
	$00 c, $08 c, $36 c, $41 c, $00 c,
	$00 c, $00 c, $77 c, $00 c, $00 c,
	$00 c, $41 c, $36 c, $08 c, $00 c,
	$02 c, $01 c, $02 c, $04 c, $02 c,
	$3C c, $26 c, $23 c, $26 c, $3C c,
	$1E c, $A1 c, $A1 c, $61 c, $12 c,
	$3A c, $40 c, $40 c, $20 c, $7A c,
	$38 c, $54 c, $54 c, $55 c, $59 c,
	$21 c, $55 c, $55 c, $79 c, $41 c,

: getfont-fwd ( n -- b1 b2 b3 b4 b5 )   \ reads in order (left to right), indexed from 0  GOOD FOR OLED OUTPUT
    5 * rawfont + 5 0 do c@+ swap loop drop ;
: getfont-rev ( n -- b5 b4 b3 b2 b1 )   \ reads in reverse into stack so display is easier  GOOD FOR LAPTOP OUTPUT WITH ROTATION
    1 + 5 * 1 - rawfont + 5 0 do c@- swap loop drop ;  
: getfont ( n -- b5 b4 b3 b2 b1 )  \ SET TO WHAT YOU WANT IT TO BE FOR YOUR APP
    getfont-rev ;

\ Display directly to screen
42 constant star
: .font 0> if star else bl then emit ;
: font-line ( b -- )   \ display one line of a 5-byte font
   init-mask begin 2dup and .font 1 rshift dup 0= until 2drop ;
: [showfont] ( b1 ... b5 -- ) 5 0 do cr font-line loop cr ;
: showfont ( n -- ) dup emit getfont-rev [showfont] ;

\ Display to screen: rotated ccw 90 deg, use * and bl for pixels
: [rotfont] ( b1 b2 b3 b4 b5 )  \ walks through and rasters by columns, outputting pixel at a time the row orientation
    7 0 do cr \ j = outside loop
    5 0 do 4 roll dup 1 j lshift and .font loop 
    loop cr 5 ndrop ;
: rotfont ( n -- ) dup emit getfont-fwd [rotfont] ;
: demofont ( -- ) 58 48 do cr i rotfont loop ;  \ show 0-9 to PC screen


\ INCLUDE 3iI2C.fs
\ SETUP OLED I2C with SSD1306 driver chip (oled-init)
\ on a 128x64 OLED, this means 16x8 characters, or 128 characters total
: .bl ( -- ) 0 0 0 0  0 0 0 0  8 oled-data ;  \ space character (16 per row on a 128x64 pixel display)
: .lf ( -- ) oled-row+ $00 1 oled-data oled-col+ ; \ linefeed: in row+ mode, sending $00 moves ptr to next OLED page (row)
: .cr ( -- ) .lf oled-rowstart ; 

: .pad ( -- ) 0 0 0 ;  \ fill out 3 pixels after character emitted (makes it an 8x8 square)
: .oled ( ascii -- ) getfont-fwd  .pad  8 oled-data ; \ emit character with 3 pixels spacing to oled
: ..oled ( sptr len -- ) 0 do c@+ .oled loop drop ;  \  print string  Ex: s" hello" ..oled
: ..oled-diag ( sptr len -- ) 0 do c@+ .oled .lf loop drop ; \ diagonal print

\ TEST routines
: oled-ascii ( -- ) oled-clear 128 0 do i dup .oled 10 mod 0 > if else key drop then loop ; 
: oled-hello ( -- ) s" Hello World!" ..oled ;

: oled-num8  s" 12345678" ..oled ;
: oled-num10 s" 0123456789" ..oled ;
: oled-numrow oled-num8 oled-num8 ;
: oled-num8fill 8 0 do oled-numrow loop ;
: oled-num8fill 8 0 do oled-numrow loop ;
: oled-num8fill 8 0 do oled-numrow loop ;
: oled-num10fill 13 0 do oled-num10 loop ;

\ can fill 16x8 char (total 128) in a 128x64 pixel screen  (each character is 8x8 pixel block)
variable count 
: count! ( n -- ) count c! ;
: count@ ( -- n ) count c@ ;
: count++ ( -- c' ) count@ 1 + 10 mod dup count! ;
\ Fills screen with continuously increasing text --- good for testing scrolling functionality
: oled-textroll count@ 128 0 do '0' + .oled count++ loop drop ;


: demo-flip
  \ pins top
  oled-pins-top  oled-window-full oled-clear 
  s" Hello World!" ..oled
  key drop
  \ pins down
  oled-pins-bottom oled-window-full oled-clear 
  s" Hello World!" ..oled
;

\ TODO: add transposed character for writing in row+ mode
\ TODO: DEMONSTRATE writing in row+ mode,  unrotated and rotated

\ ------------- MENUS --------------------

: demo-menu \ works well with yellow-blue OLED screens 128x64
oled-clear
0 10 set-pos s" MENU" ..oled
16 20 set-pos s" A. Choice 1" ..oled
24 20 set-pos s" B. Choice 2" ..oled
32 20 set-pos s" C. Choice 3" ..oled
40 20 set-pos s" D. Choice 4" ..oled
56 10 set-pos s" Select option" ..oled
;

: menu-breakfast \ works well with yellow-blue OLED screens 128x64
oled-clear
0 10 set-pos s" BREAKFAST" ..oled
16 20 set-pos s" A. Coco Pops" ..oled
24 20 set-pos s" B. Rice Krispy" ..oled
32 20 set-pos s" C. Egg McMuffy" ..oled
40 20 set-pos s" D. Alpha Bites" ..oled
56 10 set-pos s" Select option" ..oled
;


\ TODO: Port fonts to ATtiny85...
\ TODO: Create MenuSystem on ATtiny85... with left arrow and 4 buttons that engage the presses...
\ TODO: Game: guess my number
\ TODO: Game: tone and sequence guesser


\ ==========================

: help-font
   cr
   cr ." 3iFont.fs (help-font)"
   cr ." ====================="
   cr
   cr ." include 3iForth.fs  3iI2C.fs  3iFont.fs"
   cr 
   cr ." 1 open-com   rx"
   cr ." oled-init"
   cr 
   cr ." Low-Level"
   cr ." ---------"
   cr ." (on PC screen)
   cr ." 48 getfont  font-line"  
   cr ." 48 showfont 48 rotfont"
   cr ." 48  42  65  'a'"
   cr ." demofont "
   cr
   cr ." High-Level"
   cr ." ----------"
   cr ." (on oled-display)"
   cr ." char:  48  'a'  .oled"
   cr ." string:  <squote> Hello World!<squote> ..oled"
   cr ." demo-menu"   
;

help-font


\ VERSION CONTROL
\ V2 - 2021-06-10---Thu---23:45 - Added OLED out capability via I2C only (no software driver) 
\ V3 - 2021-07-24---Sat---02:42 - ADDED embedded font and fast character display 


\ Next steps:
\ + Have 1 to 4 pixel vertical spacing between rows of text
\ + Position under software control rather than the auto advance of the screen
\ + Pixel display
\ + I2C under Attiny
\ + Then can embed displays with Attiny :)
\ + Including short, tight menus
\ + EXERCISE (fun with Jasmine) - create own font! :)  Cursive handwriting program...  font editor?
\    https://en.wikipedia.org/wiki/Computer_font
\ + What about musical notes? on a staff -- can create own font for this...
\ + Scaling fonts - how to enlarge so we get bigger characters?
\ + Font types - bitmap is a matrix of pixels
\ + Bitmap graphics?  Bitmap file format?
\    https://en.wikipedia.org/wiki/BMP_file_format
\ + EXERCISE: Get AMPL logo (jaguar head) to show
\ + EXERCISE: Display a small photo... monochrome
\ + EXERCISE: ASCII Art
\    https://www.dreamstime.com/royalty-free-stock-images-typed-obama-image11549279
\ Very nice conversion tool:
\ https://www.dcode.fr/binary-image

\ 48x48 pixel AMPL jaguar outline, black text on white background
\ see 3iArt.fs

\ EXERCISE: crossword puzzle / word search
\ EXERCISE: writing column orientation by flipping the font

\ TODO: 2021-07-24---Sat---13:38 - do 2x scaling, 3x scaling for fonts...
